image: mcr.microsoft.com/dotnet/sdk

variables:
 GITLAB_REPPORT: ./Cnam.TestValidation.Kpi/

stages:
  - build
  - basic-test
  - test
  - metrics-test-job
  - package

Dot-net-build:
   stage: build
   script:
   - 'ls'
   - 'uname -a'
   - 'dotnet --version'
   - 'dotnet build'
   except:
   - tags

Unit-test:
   stage: basic-test
   needs:
     - "Dot-net-build"
   script:
   - 'dotnet test --filter "Category~Model" -l":trx;LogFileName=Unit_Test.xml"'
   except:
   - tags

Infrastructure-Test:
   stage: basic-test
   needs:
      - "Dot-net-build"
   script:
   - 'dotnet test --filter "Category~Infra" -l":trx;LogFileName=Integration_Test.xml"'
   except:
   - tags


Integration-Test:
  stage: test
  needs:
    - "Infrastructure-Test"
    - "Unit-test"
  script:
  - 'uname -a'
  - 'dotnet build'
  - 'dotnet dev-certs https --clean'
  - 'dotnet dev-certs https -ep /etc/ssl/certs/https.crt --format PEM'
  - 'update-ca-certificates' 
  - './Cnam.TestValidation.WebApi/bin/Debug/net6.0/Cnam.TestValidation.WebApi&'
  - 'dotnet test --filter "Category~Integration" -l":trx;LogFileName=Integration_Test.xml"'
  except:
  - tags

# === To fix === 
#mutation-test-job:
#  stage: test
#  script: 
#    - 'cd ./Cnam.TestValidation.Testing'
#    - 'dotnet new tool-manifest'
#    - 'dotnet tool install dotnet-stryker'
#    - 'dotnet stryker -p Cnam.TestValidation.Model.csproj'
#    - "mv ./Cnam.TestValidation.Testing/StrykerOutput/* ../{GITLAB_REPPORT}"
#  artifacts:
#      when: always
#      paths:
#        - $GITLAB_REPPORT
#      reports:
#        mutation: $GITLAB_REPPORT

# === To fix ===
# metrics-test-job:
#   stage: metrics-test-job
#   script:
#     - 'dotnet add package Microsoft.CodeAnalysis.Metrics'
#     - 'dotnet msbuild ./Cnam.TestValidation.Model /t:Metrics'
#     - $"mv ./Cnam.TestValidation.Model/Cnam.TestValidation.Model.Metrics.xml ../{GITLAB_REPPORT}"
#   artifacts:
#       when: always
#       paths:
#         - $GITLAB_REPPORT
#       reports:
#         metrics: $GITLAB_REPPORT



# publish


#deploy-job:      # This job runs in the deploy stage.
#  stage: deploy  # It only runs when *both* jobs in the test stage complete successfully.
#  script:
#    - echo "Deploying application..."
#    - echo "Application successfully deployed."
